﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Vertix: ICloneable, IComparable
    {
        public Vertix() { }
        public Vertix(double a, double b, double c, double d, double cost)
        {
            this.a = a;
            this.b = b;
            this.c = c;
            this.d = d;
            this.cost = cost;
        }

        double a;
        public double A
        {
            get { return a; }
            set { a = value; }
        }
        double b;
        public double B
        {
            get { return b; }
            set { b = value; }
        }
        double c;
        public double C
        {
            get { return c; }
            set { c = value; }
        }
        double d;
        public double D
        {
            get { return d; }
            set { d = value; }
        }
       
        double cost;
        public double Cost
        {
            get { return cost; }
            set { cost = value; }
        }
        // Simplex simp = new Simplex();

        public static Vertix TryRefluction(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            // Simplex simp = new Simplex();


            switch (i)
            {
                case 0: res.a = (best.a + secondBest.a) - worse.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 1: res.b = (best.b + secondBest.b) - worse.b;
                    res.a = updateRes.a;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 2: res.c = (best.c + secondBest.c) - worse.c;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.d = updateRes.d;
                    break;
                case 3: res.d = (best.d + secondBest.d) - worse.d;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    break;
            }
            return res;
            //vArr[1].TX = (vArr[4].TX + vArr[3].TX) - vArr[2].TX;
            //vArr[1].TY = (vArr[4].TY + vArr[3].TY) - vArr[2].TY;
            //vArr[1].A = (vArr[4].A + vArr[3].A) - vArr[2].A;
            //vArr[1].B = (vArr[4].B + vArr[3].B) - vArr[2].B;
        }

        public static Vertix TryExpansion(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = 3 * (best.a + secondBest.a) / 2 - 2 * worse.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 1: res.b = 3 * (best.b + secondBest.b) / 2 - 2 * worse.b;
                    res.a = updateRes.a;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 2: res.c = 3 * (best.c + secondBest.c) / 2 - 2 * worse.c;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.d = updateRes.d;
                    break;
                case 3: res.d = 3 * (best.d + secondBest.d) / 2 - 2 * worse.d;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    break;
            }
            return res;
            //vArr[0].TX = 3 * (vArr[4].TX + vArr[3].TX) / 2 - 2 * vArr[2].TX;
            //vArr[0].TY = 3 * (vArr[4].TY + vArr[3].TY) / 2 - 2 * vArr[2].TY;
            //vArr[0].A = 3 * (vArr[4].A + vArr[3].A) / 2 - 2 * vArr[2].A;
            //vArr[0].B = 3 * (vArr[4].B + vArr[3].B) / 2 - 2 * vArr[2].B;
        }
        public static Vertix ContractToC2(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = ((best.a + secondBest.a) / 2 - worse.a + best.a + secondBest.a) / 2;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 1: res.b = ((best.b + secondBest.b) / 2 - worse.b + best.b + secondBest.b) / 2;
                    res.a = updateRes.a;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 2: res.c = ((best.c + secondBest.c) / 2 - worse.c + best.c + secondBest.c) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.d = updateRes.d;
                    break;
                case 3: res.d = ((best.d + secondBest.d) / 2 - worse.d + best.d + secondBest.d) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    break;
            }
            return res;
            //vArr[0].TX = ((vArr[4].TX + vArr[3].TX) / 2 + vArr[1].TX) / 2; //c2
            //vArr[0].TY = ((vArr[4].TY + vArr[3].TY) / 2 + vArr[1].TY) / 2;

            //vArr[0].A = ((vArr[4].A + vArr[3].A) / 2 + vArr[1].A) / 2;
            //vArr[0].B = ((vArr[4].B + vArr[3].B) / 2 + vArr[1].B) / 2;
        }
        public static Vertix ContractToC1(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = ((best.a + secondBest.a) / 2 + worse.a) / 2;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 1: res.b = ((best.b + secondBest.b) / 2 + worse.b) / 2;
                    res.a = updateRes.a;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 2: res.c = ((best.c + secondBest.c) / 2 + worse.c) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.d = updateRes.d;
                    break;
                case 3: res.d = ((best.d + secondBest.d) / 2 + worse.d) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    break;
            }
            return res;
            //vArr[0].TX = ((vArr[4].TX + vArr[3].TX) / 2 + vArr[1].TX) / 2; //c2
            //vArr[0].TY = ((vArr[4].TY + vArr[3].TY) / 2 + vArr[1].TY) / 2;

            //vArr[0].A = ((vArr[4].A + vArr[3].A) / 2 + vArr[2].A) / 2;
            //vArr[0].B = ((vArr[4].B + vArr[3].B) / 2 + vArr[2].B) / 2;
        }
        public static Vertix ShrinkGToB(Vertix best, Vertix secondBest, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = (best.a + secondBest.a) / 2;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 1: res.b = (best.b + secondBest.b) / 2;
                    res.a = updateRes.a;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 2: res.c = (best.c + secondBest.c) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.d = updateRes.d;
                    break;
                case 3: res.d = (best.d + secondBest.d) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    break;
            }
            return res;
            
        }
        public static Vertix ShrinkWToB(Vertix best, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = (best.a + worse.a) / 2;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 1: res.b = (best.b + worse.b) / 2;
                    res.a = updateRes.a;
                    res.c = updateRes.c;
                    res.d = updateRes.d;
                    break;
                case 2: res.c = (best.c + worse.c) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.d = updateRes.d;
                    break;
                case 3: res.d = (best.d + worse.d) / 2;
                    res.a = updateRes.a;
                    res.b = updateRes.b;
                    res.c = updateRes.c;
                    break;
            }
            return res;
            
        }

        public override string ToString()
        {
            return "Cost: " + cost.ToString() + "\nA: " + a.ToString();
        }


        public object Clone()
        {
            return this.MemberwiseClone();
        }

        public int CompareTo(object obj)
        {
            int ret = 0;
            if (obj is Vertix)
            {
                Vertix vr = (Vertix)obj;
                ret = this.cost.CompareTo(vr.cost);
            }
            return ret;
        }
        
    }
}
