﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Vertix: ICloneable, IComparable
    {
        public Vertix() { }
        public Vertix(double a, double b, double cost)
        {
            this.a = a;
            this.b = b;            
            this.cost = cost;
        }

        double a;
        public double A
        {
            get { return a; }
            set { a = value; }
        }
        double b;
        public double B
        {
            get { return b; }
            set { b = value; }
        }
       
        double cost;
        public double Cost
        {
            get { return cost; }
            set { cost = value; }
        }
        // Simplex simp = new Simplex();

        public static Vertix TryRefluction(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            // Simplex simp = new Simplex();


            switch (i)
            {
                case 0: res.a = (best.a + secondBest.a) - worse.a;
                    res.b = updateRes.b;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                case 1: res.b = (best.b + secondBest.b) - worse.b;
                    res.a = updateRes.a;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                //case 2: res.tX = (int)((best.tX + secondBest.tX) - worse.tX);
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tY = updateRes.tY;
                //    break;
                //case 3: res.tY = (int)((best.tY + secondBest.tY) - worse.tY);
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tX = updateRes.tX;
                //    break;
            }
            return res;
            //vArr[1].TX = (vArr[4].TX + vArr[3].TX) - vArr[2].TX;
            //vArr[1].TY = (vArr[4].TY + vArr[3].TY) - vArr[2].TY;
            //vArr[1].A = (vArr[4].A + vArr[3].A) - vArr[2].A;
            //vArr[1].B = (vArr[4].B + vArr[3].B) - vArr[2].B;
        }

        public static Vertix TryExpansion(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = 3 * (best.a + secondBest.a) / 2 - 2 * worse.a;
                    res.b = updateRes.b;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                case 1: res.b = 3 * (best.b + secondBest.b) / 2 - 2 * worse.b;
                    res.a = updateRes.a;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                //case 2: res.tX = (int)(3 * (best.tX + secondBest.tX) / 2 - 2 * worse.tX);
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tY = updateRes.tY;
                //    break;
                //case 3: res.tY = (int)(3 * (best.tY + secondBest.tY) / 2 - 2 * worse.tY);
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tX = updateRes.tX;
                //    break;
            }
            return res;
            //vArr[0].TX = 3 * (vArr[4].TX + vArr[3].TX) / 2 - 2 * vArr[2].TX;
            //vArr[0].TY = 3 * (vArr[4].TY + vArr[3].TY) / 2 - 2 * vArr[2].TY;
            //vArr[0].A = 3 * (vArr[4].A + vArr[3].A) / 2 - 2 * vArr[2].A;
            //vArr[0].B = 3 * (vArr[4].B + vArr[3].B) / 2 - 2 * vArr[2].B;
        }
        public static Vertix ContractToC2(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = ((best.a + secondBest.a) / 2 - worse.a + best.a + secondBest.a) / 2;
                    res.b = updateRes.b;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                case 1: res.b = ((best.b + secondBest.b) / 2 - worse.b + best.b + secondBest.b) / 2;
                    res.a = updateRes.a;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                //case 2: res.tX = (int)(((best.tX + secondBest.tX) / 2 - worse.tX + best.tX + secondBest.tX) / 2);
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tY = updateRes.tY;
                //    break;
                //case 3: res.tY = (int)(((best.tY + secondBest.tY) / 2 - worse.tY + best.tY + secondBest.tY) / 2);
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tX = updateRes.tX;
                //    break;
            }
            return res;
            //vArr[0].TX = ((vArr[4].TX + vArr[3].TX) / 2 + vArr[1].TX) / 2; //c2
            //vArr[0].TY = ((vArr[4].TY + vArr[3].TY) / 2 + vArr[1].TY) / 2;

            //vArr[0].A = ((vArr[4].A + vArr[3].A) / 2 + vArr[1].A) / 2;
            //vArr[0].B = ((vArr[4].B + vArr[3].B) / 2 + vArr[1].B) / 2;
        }
        public static Vertix ContractToC1(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = ((best.a + secondBest.a) / 2 + worse.a) / 2;
                    res.b = updateRes.b;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                case 1: res.b = ((best.b + secondBest.b) / 2 + worse.b) / 2;
                    res.a = updateRes.a;
                    //res.tX = updateRes.tX;
                    //res.tY = updateRes.tY;
                    break;
                //case 2: res.tX = (int)((best.tX + secondBest.tX) / 2 + worse.tX) / 2;
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tY = updateRes.tY;
                //    break;
                //case 3: res.tY = (int)((best.tY + secondBest.tY) / 2 + worse.tY) / 2;
                //    res.a = updateRes.a;
                //    res.b = updateRes.b;
                //    res.tX = updateRes.tX;
                //    break;
            }
            return res;
            //vArr[0].TX = ((vArr[4].TX + vArr[3].TX) / 2 + vArr[1].TX) / 2; //c2
            //vArr[0].TY = ((vArr[4].TY + vArr[3].TY) / 2 + vArr[1].TY) / 2;

            //vArr[0].A = ((vArr[4].A + vArr[3].A) / 2 + vArr[2].A) / 2;
            //vArr[0].B = ((vArr[4].B + vArr[3].B) / 2 + vArr[2].B) / 2;
        }
        public static Vertix ShrinkGToB(Vertix best, Vertix secondBest, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = (best.a + secondBest.a) / 2;
                    res.b = updateRes.b;
                    
                    break;
                case 1: res.b = (best.b + secondBest.b) / 2;
                    res.a = updateRes.a;
                   
                    break;
                
            }
            return res;
            
        }
        public static Vertix ShrinkWToB(Vertix best, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.a = (best.a + worse.a) / 2;
                    res.b = updateRes.b;
                    
                    break;
                case 1: res.b = (best.b + worse.b) / 2;
                    res.a = updateRes.a;
                   
                    break;
               
            }
            return res;
            
        }

        public override string ToString()
        {
            return "Cost: " + cost.ToString() + "\nA: " + a.ToString();
        }


        public object Clone()
        {
            return this.MemberwiseClone();
        }

        public int CompareTo(object obj)
        {
            int ret = 0;
            if (obj is Vertix)
            {
                Vertix vr = (Vertix)obj;
                ret = this.cost.CompareTo(vr.cost);
            }
            return ret;
        }
        
    }
}
