﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace RosenBrockFunction
{
    class Vertix: ICloneable, IComparable
    {
        public Vertix() { }
        public Vertix(double x1, double x2, double x3, double x4, double x5, double x6, double cost)
        {
            this.x1 = x1;
            this.x2 = x2;
            this.x3 = x3;
            this.x4 = x4;
            this.x5 = x5;
            this.x6 = x6;
            this.cost = cost;
        }

        double x1;
        public double X1
        {
            get { return x1; }
            set { x1 = value; }
        }
        double x2;
        public double X2
        {
            get { return x2; }
            set { x2 = value; }
        }
        double x3;
        public double X3
        {
            get { return x3; }
            set { x3 = value; }
        }
        double x4;
        public double X4
        {
            get { return x4; }
            set { x4 = value; }
        }
        double x5;
        public double X5
        {
            get { return x5; }
            set { x5 = value; }
        }
        double x6;
        public double X6
        {
            get { return x6; }
            set { x6 = value; }
        }
       
        double cost;
        public double Cost
        {
            get { return cost; }
            set { cost = value; }
        }
        // Simplex simp = new Simplex();

        public static Vertix TryRefluction(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            // Simplex simp = new Simplex();


            switch (i)
            {
                case 0: res.x1 = (best.x1 + secondBest.x1) - worse.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 1: res.x2 = (best.x2 + secondBest.x2) - worse.x2;
                    res.x1 = updateRes.x1;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 2: res.x3 = (best.x3 + secondBest.x3) - worse.x3;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 3: res.x4 = (best.x4 + secondBest.x4) - worse.x4;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 4: res.x5 = (best.x5 + secondBest.x5) - worse.x5;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x6 = updateRes.x6;
                    break;
                case 5: res.x6 = (best.x6 + secondBest.x6) - worse.x6;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    break;
            }
            return res;
            //vArr[1].TX = (vArr[4].TX + vArr[3].TX) - vArr[2].TX;
            //vArr[1].TY = (vArr[4].TY + vArr[3].TY) - vArr[2].TY;
            //vArr[1].A = (vArr[4].A + vArr[3].A) - vArr[2].A;
            //vArr[1].B = (vArr[4].B + vArr[3].B) - vArr[2].B;
        }

        public static Vertix TryExpansion(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.x1 = 3 * (best.x1 + secondBest.x1) / 2 - 2 * worse.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 1: res.x2 = 3 * (best.x2 + secondBest.x2) / 2 - 2 * worse.x2;
                    res.x1 = updateRes.x1;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 2: res.x3 = 3 * (best.x3 + secondBest.x3) / 2 - 2 * worse.x3;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 3: res.x4 = 3 * (best.x4 + secondBest.x4) / 2 - 2 * worse.x4;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 4: res.x5 = 3 * (best.x5 + secondBest.x5) / 2 - 2 * worse.x5;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x6 = updateRes.x6;
                    break;
                case 5: res.x6 = 3 * (best.x6 + secondBest.x6) / 2 - 2 * worse.x6;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    break;
            }
            return res;
            //vArr[0].TX = 3 * (vArr[4].TX + vArr[3].TX) / 2 - 2 * vArr[2].TX;
            //vArr[0].TY = 3 * (vArr[4].TY + vArr[3].TY) / 2 - 2 * vArr[2].TY;
            //vArr[0].A = 3 * (vArr[4].A + vArr[3].A) / 2 - 2 * vArr[2].A;
            //vArr[0].B = 3 * (vArr[4].B + vArr[3].B) / 2 - 2 * vArr[2].B;
        }
        public static Vertix ContractToC2(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.x1 = ((best.x1 + secondBest.x1) / 2 - worse.x1 + best.x1 + secondBest.x1) / 2;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 1: res.x2 = ((best.x2 + secondBest.x2) / 2 - worse.x2 + best.x2 + secondBest.x2) / 2;
                    res.x1 = updateRes.x1;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 2: res.x3 = ((best.x3 + secondBest.x3) / 2 - worse.x3 + best.x3 + secondBest.x3) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 3: res.x4 = ((best.x4 + secondBest.x4) / 2 - worse.x4 + best.x4 + secondBest.x4) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 4: res.x5 = ((best.x5 + secondBest.x5) / 2 - worse.x5 + best.x5 + secondBest.x5) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x6 = updateRes.x6;
                    break;
                case 5: res.x6 = ((best.x6 + secondBest.x6) / 2 - worse.x6 + best.x6 + secondBest.x6) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    break;
            }
            return res;
            //vArr[0].TX = ((vArr[4].TX + vArr[3].TX) / 2 + vArr[1].TX) / 2; //c2
            //vArr[0].TY = ((vArr[4].TY + vArr[3].TY) / 2 + vArr[1].TY) / 2;

            //vArr[0].A = ((vArr[4].A + vArr[3].A) / 2 + vArr[1].A) / 2;
            //vArr[0].B = ((vArr[4].B + vArr[3].B) / 2 + vArr[1].B) / 2;
        }
        public static Vertix ContractToC1(Vertix best, Vertix secondBest, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.x1 = ((best.x1 + secondBest.x1) / 2 + worse.x1) / 2;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 1: res.x2 = ((best.x2 + secondBest.x2) / 2 + worse.x2) / 2;
                    res.x1 = updateRes.x1;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 2: res.x3 = ((best.x3 + secondBest.x3) / 2 + worse.x3) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 3: res.x4 = ((best.x4 + secondBest.x4) / 2 + worse.x4) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 4: res.x5 = ((best.x5 + secondBest.x5) / 2 + worse.x5) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x6 = updateRes.x6;
                    break;
                case 5: res.x6 = ((best.x6 + secondBest.x6) / 2 + worse.x6) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    break;
            }
            return res;
            //vArr[0].TX = ((vArr[4].TX + vArr[3].TX) / 2 + vArr[1].TX) / 2; //c2
            //vArr[0].TY = ((vArr[4].TY + vArr[3].TY) / 2 + vArr[1].TY) / 2;

            //vArr[0].A = ((vArr[4].A + vArr[3].A) / 2 + vArr[2].A) / 2;
            //vArr[0].B = ((vArr[4].B + vArr[3].B) / 2 + vArr[2].B) / 2;
        }
        public static Vertix ShrinkGToB(Vertix best, Vertix secondBest, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.x1 = (best.x1 + secondBest.x1) / 2;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 1: res.x2 = (best.x2 + secondBest.x2) / 2;
                    res.x1 = updateRes.x1;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 2: res.x3 = (best.x3 + secondBest.x3) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 3: res.x4 = (best.x4 + secondBest.x4) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 4: res.x5 = (best.x5 + secondBest.x5) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x6 = updateRes.x6;
                    break;
                case 5: res.x6 = (best.x6 + secondBest.x6) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    break;
            }
            return res;
            
        }
        public static Vertix ShrinkWToB(Vertix best, Vertix worse, Vertix updateRes, int i)  //Calculate Refluction
        {
            Vertix res = new Vertix();
            switch (i)
            {
                case 0: res.x1 = (best.x1 + worse.x1) / 2;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 1: res.x2 = (best.x2 + worse.x2) / 2;
                    res.x1 = updateRes.x1;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 2: res.x3 = (best.x3 + worse.x3) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 3: res.x4 = (best.x4 + worse.x4) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x5 = updateRes.x5;
                    res.x6 = updateRes.x6;
                    break;
                case 4: res.x5 = (best.x5 + worse.x5) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x6 = updateRes.x6;
                    break;
                case 5: res.x6 = (best.x6 + worse.x6) / 2;
                    res.x1 = updateRes.x1;
                    res.x2 = updateRes.x2;
                    res.x3 = updateRes.x3;
                    res.x4 = updateRes.x4;
                    res.x5 = updateRes.x5;
                    break;
            }
            return res;
            
        }

        public override string ToString()
        {
            return "Cost: " + cost.ToString() + "\nA: " + x1.ToString();
        }


        public object Clone()
        {
            return this.MemberwiseClone();
        }

        public int CompareTo(object obj)
        {
            int ret = 0;
            if (obj is Vertix)
            {
                Vertix vr = (Vertix)obj;
                ret = this.cost.CompareTo(vr.cost);
            }
            return ret;
        }
        
    }
}
